<template>
  <AppButton
    :classes="['buttonSorting', 'buttonAsLink', '_transparent', sortClasses[criterion]]"
    @click.native="orderChange">
    <span
      slot="button-item"
      class="button-item">
      Сортировать по дате публикации
      <img
        svg-inline
        src="~/assets/svg/redesign/button-arrow-down.svg">
    </span>
  </AppButton>
</template>

<script>
import { has } from 'lodash-es';
import AppButton from '~/components/redesign/app-buttons/app-button';

export default {
  name: 'ButtonWithSorting',
  components: {
    AppButton,
  },
  props: {
    criterion: {
      type: String,
      default: '',
    },
    gridType: {
      type: String,
      default: '',
    },
    order: {
      type: Object,
      default() { return {}; },
    },
  },
  computed: {
    sortClasses() {
      const direction = {
        created_at: 'none',
      };

      if (has(direction, this.order.field)) {
        direction[this.order.field] = (this.order.direction === 'asc' ? '-sorting-up' : '-sorting-down');
      }

      return direction;
    },
  },
  methods: {
    orderChange() {
      let direction = 'asc';

      if (this.criterion === this.order.field) {
        direction = this.order.direction === 'asc' ? 'desc' : 'asc';
      }

      this.$emit('order-change', this.gridType, {
        field: this.criterion,
        direction,
      });
    },
  },
};
</script>

<style lang="postcss">

</style>
